# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ScalingLifecycleHooksResult',
    'AwaitableScalingLifecycleHooksResult',
    'scaling_lifecycle_hooks',
    'scaling_lifecycle_hooks_output',
]

@pulumi.output_type
class ScalingLifecycleHooksResult:
    """
    A collection of values returned by ScalingLifecycleHooks.
    """
    def __init__(__self__, id=None, ids=None, lifecycle_hook_names=None, lifecycle_hooks=None, name_regex=None, output_file=None, scaling_group_id=None, total_count=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if lifecycle_hook_names and not isinstance(lifecycle_hook_names, list):
            raise TypeError("Expected argument 'lifecycle_hook_names' to be a list")
        pulumi.set(__self__, "lifecycle_hook_names", lifecycle_hook_names)
        if lifecycle_hooks and not isinstance(lifecycle_hooks, list):
            raise TypeError("Expected argument 'lifecycle_hooks' to be a list")
        pulumi.set(__self__, "lifecycle_hooks", lifecycle_hooks)
        if name_regex and not isinstance(name_regex, str):
            raise TypeError("Expected argument 'name_regex' to be a str")
        pulumi.set(__self__, "name_regex", name_regex)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if scaling_group_id and not isinstance(scaling_group_id, str):
            raise TypeError("Expected argument 'scaling_group_id' to be a str")
        pulumi.set(__self__, "scaling_group_id", scaling_group_id)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter(name="lifecycleHookNames")
    def lifecycle_hook_names(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "lifecycle_hook_names")

    @property
    @pulumi.getter(name="lifecycleHooks")
    def lifecycle_hooks(self) -> Sequence['outputs.ScalingLifecycleHooksLifecycleHookResult']:
        """
        The collection of lifecycle hook query.
        """
        return pulumi.get(self, "lifecycle_hooks")

    @property
    @pulumi.getter(name="nameRegex")
    def name_regex(self) -> Optional[str]:
        return pulumi.get(self, "name_regex")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="scalingGroupId")
    def scaling_group_id(self) -> str:
        """
        The id of the scaling group.
        """
        return pulumi.get(self, "scaling_group_id")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of lifecycle hook query.
        """
        return pulumi.get(self, "total_count")


class AwaitableScalingLifecycleHooksResult(ScalingLifecycleHooksResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ScalingLifecycleHooksResult(
            id=self.id,
            ids=self.ids,
            lifecycle_hook_names=self.lifecycle_hook_names,
            lifecycle_hooks=self.lifecycle_hooks,
            name_regex=self.name_regex,
            output_file=self.output_file,
            scaling_group_id=self.scaling_group_id,
            total_count=self.total_count)


def scaling_lifecycle_hooks(ids: Optional[Sequence[str]] = None,
                            lifecycle_hook_names: Optional[Sequence[str]] = None,
                            name_regex: Optional[str] = None,
                            output_file: Optional[str] = None,
                            scaling_group_id: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableScalingLifecycleHooksResult:
    """
    Use this data source to query detailed information of scaling lifecycle hooks
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    default = volcengine.autoscaling.scaling_lifecycle_hooks(scaling_group_id="scg-ybru8pazhgl8j1di4tyd")
    ```


    :param Sequence[str] ids: A list of lifecycle hook ids.
    :param Sequence[str] lifecycle_hook_names: A list of lifecycle hook names.
    :param str name_regex: A Name Regex of lifecycle hook.
    :param str output_file: File name where to save data source results.
    :param str scaling_group_id: An id of scaling group id.
    """
    __args__ = dict()
    __args__['ids'] = ids
    __args__['lifecycleHookNames'] = lifecycle_hook_names
    __args__['nameRegex'] = name_regex
    __args__['outputFile'] = output_file
    __args__['scalingGroupId'] = scaling_group_id
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('volcengine:autoscaling/scalingLifecycleHooks:ScalingLifecycleHooks', __args__, opts=opts, typ=ScalingLifecycleHooksResult).value

    return AwaitableScalingLifecycleHooksResult(
        id=__ret__.id,
        ids=__ret__.ids,
        lifecycle_hook_names=__ret__.lifecycle_hook_names,
        lifecycle_hooks=__ret__.lifecycle_hooks,
        name_regex=__ret__.name_regex,
        output_file=__ret__.output_file,
        scaling_group_id=__ret__.scaling_group_id,
        total_count=__ret__.total_count)


@_utilities.lift_output_func(scaling_lifecycle_hooks)
def scaling_lifecycle_hooks_output(ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                   lifecycle_hook_names: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                   name_regex: Optional[pulumi.Input[Optional[str]]] = None,
                                   output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                   scaling_group_id: Optional[pulumi.Input[str]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ScalingLifecycleHooksResult]:
    """
    Use this data source to query detailed information of scaling lifecycle hooks
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    default = volcengine.autoscaling.scaling_lifecycle_hooks(scaling_group_id="scg-ybru8pazhgl8j1di4tyd")
    ```


    :param Sequence[str] ids: A list of lifecycle hook ids.
    :param Sequence[str] lifecycle_hook_names: A list of lifecycle hook names.
    :param str name_regex: A Name Regex of lifecycle hook.
    :param str output_file: File name where to save data source results.
    :param str scaling_group_id: An id of scaling group id.
    """
    ...
