# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'SslStatesResult',
    'AwaitableSslStatesResult',
    'ssl_states',
    'ssl_states_output',
]

@pulumi.output_type
class SslStatesResult:
    """
    A collection of values returned by SslStates.
    """
    def __init__(__self__, id=None, instance_id=None, output_file=None, ssl_states=None, total_count=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if ssl_states and not isinstance(ssl_states, list):
            raise TypeError("Expected argument 'ssl_states' to be a list")
        pulumi.set(__self__, "ssl_states", ssl_states)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        The mongodb instance id.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="sslStates")
    def ssl_states(self) -> Sequence['outputs.SslStatesSslStateResult']:
        """
        The collection of mongodb ssl state query.
        """
        return pulumi.get(self, "ssl_states")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of mongodb ssl state query.
        """
        return pulumi.get(self, "total_count")


class AwaitableSslStatesResult(SslStatesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return SslStatesResult(
            id=self.id,
            instance_id=self.instance_id,
            output_file=self.output_file,
            ssl_states=self.ssl_states,
            total_count=self.total_count)


def ssl_states(instance_id: Optional[str] = None,
               output_file: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableSslStatesResult:
    """
    Use this data source to query detailed information of mongodb ssl states
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.mongodb.ssl_states(instance_id="mongo-replica-f16e9298b121")
    ```


    :param str instance_id: The mongodb instance ID to query.
    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['outputFile'] = output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('volcengine:mongodb/sslStates:SslStates', __args__, opts=opts, typ=SslStatesResult).value

    return AwaitableSslStatesResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        output_file=__ret__.output_file,
        ssl_states=__ret__.ssl_states,
        total_count=__ret__.total_count)


@_utilities.lift_output_func(ssl_states)
def ssl_states_output(instance_id: Optional[pulumi.Input[str]] = None,
                      output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[SslStatesResult]:
    """
    Use this data source to query detailed information of mongodb ssl states
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.mongodb.ssl_states(instance_id="mongo-replica-f16e9298b121")
    ```


    :param str instance_id: The mongodb instance ID to query.
    :param str output_file: File name where to save data source results.
    """
    ...
